//
// Created by william on 12/30/23.
//

#include <stddef.h>
#include "../include/ppu.h"

void ppu_init(PPU *ppu, byte *registers_ram, byte *oam_dma_register) {
    ppu->registers = registers_ram;
    ppu->registers[PPU_REGISTER_CTRL] = 0x00;
    ppu->registers[PPU_REGISTER_MASK] = 0x00;
    ppu->registers[PPU_REGISTER_STATUS] = 0x00;
    ppu->registers[PPU_REGISTER_OAM_ADDR] = 0x00;
    ppu->registers[PPU_REGISTER_OAM_DATA] = 0x00;
    ppu->registers[PPU_REGISTER_SCROLL] = 0x00;
    ppu->registers[PPU_REGISTER_ADDR] = 0x00;
    ppu->registers[PPU_REGISTER_DATA] = 0x00;
    ppu->oam_dma_register = oam_dma_register;
    ppu->odd_frame = false;
}

void ppu_cycle(PPU *ppu) {
}

bool ppu_read_flag(PPU *ppu, size_t reg, byte mask) {
    return ppu->registers[reg] & mask;
}

//byte ppu_read_register(PPU *ppu, size_t reg, byte mask) {
//    return ppu->registers[reg] & mask;
//}

void ppu_read_register(PPU *ppu, byte reg) {
    if (reg == PPU_REGISTER_STATUS) {
        ppu->w = false;
    }
}

void ppu_write_register(PPU *ppu, byte reg) {
    if (reg == PPU_REGISTER_SCROLL || reg == PPU_REGISTER_ADDR) {
        ppu->w = !ppu->w;
    }

    if (reg == PPU_REGISTER_OAM_DATA) {
        ppu->registers[PPU_REGISTER_OAM_ADDR]++;
    }
}